/* extension_db.h:
 * the extension database system.
 * I guess this could be implemented with a C++ string and map,
 * but I don't have the documentation with OSX.
 */


#ifndef EXTENSION_DB_H
#define EXTENSION_DB_H
#include <stdio.h>

class extension_db {
public:
    struct ent {
	int partial[4];			// number of partial level 0..3 files
	int complete[4];		// number of complete level 0..3 files
    };
    void init();
    extension_db();
    void add(const char *fname,struct ent e);
    void report(FILE *outfile);
    int  count(struct ent e);
    void report(FILE *outfile,struct ent e);
private:
    struct ent db[37*37*37];			// the database
    static int idx(char c) {
	if(c>='0' && c<='9') return 1 + c - '0';
	if(c>='a' && c<='z') return 11 + c - 'a';
	if(c>='A' && c<='Z') return 11 + c - 'A';
	return 0;			// unmapped character
    }
    static int extension_index(const char *str);
};
#endif
