#ifndef FFS_CHAIN_H
#define FFS_CHAIN_H

#include <stdio.h>

/* chains; we seem to use these a lot. They could be implemented better,
 * perhaps with a linked list. There could be a hash too...
 */
class ffs_chain {
    unsigned int *elems_;
    unsigned int numelems_;	// number of blocks in line
public:
    
    ffs_chain();
    ~ffs_chain();
    void init();			// reset a chain
    bool contains(unsigned int num); // does it have the sector? 
    bool add(unsigned int num);	// add a sector to the chain; O(n^2) unfortunately
    int count() { return numelems_;}
    unsigned int elem(unsigned int i) { return i<numelems_ ? elems_[i]  : 0;}
    // returns false if cannot add
    void print(FILE *out);			// print to stdout
};

#endif
